// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMORPHINGANIMATIONWRAPPER_H
#define SBK_QMORPHINGANIMATIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DAnimation/qmorphinganimation.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QMorphingAnimationWrapper : public Qt3DAnimation::QMorphingAnimation
{
public:
    QMorphingAnimationWrapper(::QObject * parent = nullptr);
    QMorphingAnimationWrapper(const QMorphingAnimationWrapper &) = delete;
    QMorphingAnimationWrapper& operator=(const QMorphingAnimationWrapper &) = delete;
    QMorphingAnimationWrapper(QMorphingAnimationWrapper &&) = delete;
    QMorphingAnimationWrapper& operator=(QMorphingAnimationWrapper &&) = delete;
    ~QMorphingAnimationWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QMORPHINGANIMATIONWRAPPER_H
