// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTFUNCTORWRAPPER_H
#define SBK_QABSTRACTFUNCTORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DCore/qabstractfunctor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAbstractFunctorWrapper : public Qt3DCore::QAbstractFunctor
{
public:
    QAbstractFunctorWrapper();
    QAbstractFunctorWrapper(const QAbstractFunctorWrapper &) = delete;
    QAbstractFunctorWrapper& operator=(const QAbstractFunctorWrapper &) = delete;
    QAbstractFunctorWrapper(QAbstractFunctorWrapper &&) = delete;
    QAbstractFunctorWrapper& operator=(QAbstractFunctorWrapper &&) = delete;
    ~QAbstractFunctorWrapper() override;

    ::qintptr id() const override;
    static ::qintptr sbk_o_id(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QABSTRACTFUNCTORWRAPPER_H
