// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBACKENDNODEWRAPPER_H
#define SBK_QBACKENDNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DCore/qbackendnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QBackendNodeWrapper : public Qt3DCore::QBackendNode
{
public:
    QBackendNodeWrapper(::Qt3DCore::QBackendNode::Mode mode = Qt3DCore::QBackendNode::Mode::ReadOnly);
    QBackendNodeWrapper(const QBackendNodeWrapper &) = delete;
    QBackendNodeWrapper& operator=(const QBackendNodeWrapper &) = delete;
    QBackendNodeWrapper(QBackendNodeWrapper &&) = delete;
    QBackendNodeWrapper& operator=(QBackendNodeWrapper &&) = delete;
    ~QBackendNodeWrapper() override;

    void syncFromFrontEnd(const ::Qt3DCore::QNode * frontEnd, bool firstTime) override;
    static void sbk_o_syncFromFrontEnd(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::Qt3DCore::QNode * frontEnd, bool firstTime);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QBACKENDNODEWRAPPER_H
