// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QLOGICALDEVICEWRAPPER_H
#define SBK_QLOGICALDEVICEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DInput/qlogicaldevice.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QLogicalDeviceWrapper : public Qt3DInput::QLogicalDevice
{
public:
    QLogicalDeviceWrapper(::Qt3DCore::QNode * parent = nullptr);
    QLogicalDeviceWrapper(const QLogicalDeviceWrapper &) = delete;
    QLogicalDeviceWrapper& operator=(const QLogicalDeviceWrapper &) = delete;
    QLogicalDeviceWrapper(QLogicalDeviceWrapper &&) = delete;
    QLogicalDeviceWrapper& operator=(QLogicalDeviceWrapper &&) = delete;
    ~QLogicalDeviceWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QLOGICALDEVICEWRAPPER_H
