// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPAINTEDTEXTUREIMAGEWRAPPER_H
#define SBK_QPAINTEDTEXTUREIMAGEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qpaintedtextureimage.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QPaintedTextureImageWrapper : public Qt3DRender::QPaintedTextureImage
{
public:
    QPaintedTextureImageWrapper(::Qt3DCore::QNode * parent = nullptr);
    QPaintedTextureImageWrapper(const QPaintedTextureImageWrapper &) = delete;
    QPaintedTextureImageWrapper& operator=(const QPaintedTextureImageWrapper &) = delete;
    QPaintedTextureImageWrapper(QPaintedTextureImageWrapper &&) = delete;
    QPaintedTextureImageWrapper& operator=(QPaintedTextureImageWrapper &&) = delete;
    ~QPaintedTextureImageWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void paint(::QPainter * painter) override;
    static void sbk_o_paint(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QPainter * painter);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[8] = {false, false, false, false, false, false, false, false};
};

#endif // SBK_QPAINTEDTEXTUREIMAGEWRAPPER_H
