// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTEXTUREIMAGEDATAGENERATORWRAPPER_H
#define SBK_QTEXTUREIMAGEDATAGENERATORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Qt3DRender/qtextureimagedatagenerator.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QTextureImageDataGeneratorWrapper : public Qt3DRender::QTextureImageDataGenerator
{
public:
    QTextureImageDataGeneratorWrapper();
    QTextureImageDataGeneratorWrapper(const QTextureImageDataGeneratorWrapper &) = delete;
    QTextureImageDataGeneratorWrapper& operator=(const QTextureImageDataGeneratorWrapper &) = delete;
    QTextureImageDataGeneratorWrapper(QTextureImageDataGeneratorWrapper &&) = delete;
    QTextureImageDataGeneratorWrapper& operator=(QTextureImageDataGeneratorWrapper &&) = delete;
    ~QTextureImageDataGeneratorWrapper() override;

    ::qintptr id() const override;
    static ::qintptr sbk_o_id(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QSharedPointer<Qt3DRender::QTextureImageData> operator()() override;
    static ::QSharedPointer<Qt3DRender::QTextureImageData> sbk_o_op_call(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    bool operator==(const ::Qt3DRender::QTextureImageDataGenerator & other) const override;
    static bool sbk_o_op_eq(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::Qt3DRender::QTextureImageDataGenerator & other);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QTEXTUREIMAGEDATAGENERATORWRAPPER_H
