// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBOXPLOTLEGENDMARKERWRAPPER_H
#define SBK_QBOXPLOTLEGENDMARKERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtCharts/qboxplotlegendmarker.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QBoxPlotLegendMarkerWrapper : public QBoxPlotLegendMarker
{
public:
    QBoxPlotLegendMarkerWrapper(::QBoxPlotSeries * series, ::QLegend * legend, ::QObject * parent = nullptr);
    QBoxPlotLegendMarkerWrapper(const QBoxPlotLegendMarkerWrapper &) = delete;
    QBoxPlotLegendMarkerWrapper& operator=(const QBoxPlotLegendMarkerWrapper &) = delete;
    QBoxPlotLegendMarkerWrapper(QBoxPlotLegendMarkerWrapper &&) = delete;
    QBoxPlotLegendMarkerWrapper& operator=(QBoxPlotLegendMarkerWrapper &&) = delete;
    ~QBoxPlotLegendMarkerWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QBoxPlotSeries * series() override;
    static ::QBoxPlotSeries * sbk_o_series(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void timerEvent(::QTimerEvent * event) override;
    ::QLegendMarker::LegendMarkerType type() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QBOXPLOTLEGENDMARKERWRAPPER_H
