// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCHILDEVENTWRAPPER_H
#define SBK_QCHILDEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QChildEventWrapper : public QChildEvent
{
public:
    QChildEventWrapper(::QEvent::Type type, ::QObject * child);
    QChildEventWrapper(const QChildEventWrapper &) = delete;
    QChildEventWrapper(const QChildEvent& self) : QChildEvent(self)
    {
    }
    QChildEventWrapper& operator=(const QChildEventWrapper &) = delete;
    QChildEventWrapper(QChildEventWrapper &&) = delete;
    QChildEventWrapper& operator=(QChildEventWrapper &&) = delete;
    ~QChildEventWrapper() override;

    ::QChildEvent * clone() const override;
    static ::QChildEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QCHILDEVENTWRAPPER_H
