// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFACTORYINTERFACEWRAPPER_H
#define SBK_QFACTORYINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qfactoryinterface.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QFactoryInterfaceWrapper : public QFactoryInterface
{
public:
    QFactoryInterfaceWrapper();
    QFactoryInterfaceWrapper(const QFactoryInterfaceWrapper &) = delete;
    QFactoryInterfaceWrapper& operator=(const QFactoryInterfaceWrapper &) = delete;
    QFactoryInterfaceWrapper(QFactoryInterfaceWrapper &&) = delete;
    QFactoryInterfaceWrapper& operator=(QFactoryInterfaceWrapper &&) = delete;
    ~QFactoryInterfaceWrapper() override;

    ::QStringList keys() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QFACTORYINTERFACEWRAPPER_H
