// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSEQUENTIALANIMATIONGROUPWRAPPER_H
#define SBK_QSEQUENTIALANIMATIONGROUPWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qsequentialanimationgroup.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QSequentialAnimationGroupWrapper : public QSequentialAnimationGroup
{
public:
    QSequentialAnimationGroupWrapper(::QObject * parent = nullptr);
    QSequentialAnimationGroupWrapper(const QSequentialAnimationGroupWrapper &) = delete;
    QSequentialAnimationGroupWrapper& operator=(const QSequentialAnimationGroupWrapper &) = delete;
    QSequentialAnimationGroupWrapper(QSequentialAnimationGroupWrapper &&) = delete;
    QSequentialAnimationGroupWrapper& operator=(QSequentialAnimationGroupWrapper &&) = delete;
    ~QSequentialAnimationGroupWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    int duration() const override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    void updateCurrentTime(int arg__1) override;
    void updateDirection(::QAbstractAnimation::Direction direction) override;
    void updateState(::QAbstractAnimation::State newState, ::QAbstractAnimation::State oldState) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QSEQUENTIALANIMATIONGROUPWRAPPER_H
