// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QVALUE3DAXISFORMATTERWRAPPER_H
#define SBK_QVALUE3DAXISFORMATTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDataVisualization/qvalue3daxisformatter.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QValue3DAxisFormatterWrapper : public QValue3DAxisFormatter
{
public:
    QValue3DAxisFormatterWrapper(::QObject * parent = nullptr);
    QValue3DAxisFormatterWrapper(const QValue3DAxisFormatterWrapper &) = delete;
    QValue3DAxisFormatterWrapper& operator=(const QValue3DAxisFormatterWrapper &) = delete;
    QValue3DAxisFormatterWrapper(QValue3DAxisFormatterWrapper &&) = delete;
    QValue3DAxisFormatterWrapper& operator=(QValue3DAxisFormatterWrapper &&) = delete;
    ~QValue3DAxisFormatterWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QValue3DAxisFormatter * createNewInstance() const override;
    static ::QValue3DAxisFormatter * sbk_o_createNewInstance(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void populateCopy(::QValue3DAxisFormatter & copy) const override;
    static void sbk_o_populateCopy(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QValue3DAxisFormatter & copy);
    float positionAt(float value) const override;
    static float sbk_o_positionAt(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, float value);
    void recalculate() override;
    static void sbk_o_recalculate(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QString stringForValue(qreal value, const ::QString & format) const override;
    static ::QString sbk_o_stringForValue(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, qreal value, const ::QString & format);
    void timerEvent(::QTimerEvent * event) override;
    float valueAt(float position) const override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QVALUE3DAXISFORMATTERWRAPPER_H
