// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTEXTENSIONMANAGERWRAPPER_H
#define SBK_QABSTRACTEXTENSIONMANAGERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/extension.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAbstractExtensionManagerWrapper : public QAbstractExtensionManager
{
public:
    QAbstractExtensionManagerWrapper();
    QAbstractExtensionManagerWrapper(const QAbstractExtensionManagerWrapper &) = delete;
    QAbstractExtensionManagerWrapper& operator=(const QAbstractExtensionManagerWrapper &) = delete;
    QAbstractExtensionManagerWrapper(QAbstractExtensionManagerWrapper &&) = delete;
    QAbstractExtensionManagerWrapper& operator=(QAbstractExtensionManagerWrapper &&) = delete;
    ~QAbstractExtensionManagerWrapper() override;

    ::QObject * extension(::QObject * object, const ::QString & iid) const override;
    static ::QObject * sbk_o_extension(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * object, const ::QString & iid);
    void registerExtensions(::QAbstractExtensionFactory * factory, const ::QString & iid) override;
    static void sbk_o_registerExtensions(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QAbstractExtensionFactory * factory, const ::QString & iid);
    void unregisterExtensions(::QAbstractExtensionFactory * factory, const ::QString & iid) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QABSTRACTEXTENSIONMANAGERWRAPPER_H
