// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERFORMWINDOWCURSORINTERFACEWRAPPER_H
#define SBK_QDESIGNERFORMWINDOWCURSORINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractformwindowcursor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDesignerFormWindowCursorInterfaceWrapper : public QDesignerFormWindowCursorInterface
{
public:
    QDesignerFormWindowCursorInterfaceWrapper();
    QDesignerFormWindowCursorInterfaceWrapper(const QDesignerFormWindowCursorInterfaceWrapper &) = delete;
    QDesignerFormWindowCursorInterfaceWrapper& operator=(const QDesignerFormWindowCursorInterfaceWrapper &) = delete;
    QDesignerFormWindowCursorInterfaceWrapper(QDesignerFormWindowCursorInterfaceWrapper &&) = delete;
    QDesignerFormWindowCursorInterfaceWrapper& operator=(QDesignerFormWindowCursorInterfaceWrapper &&) = delete;
    ~QDesignerFormWindowCursorInterfaceWrapper() override;

    ::QWidget * current() const override;
    static ::QWidget * sbk_o_current(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QDesignerFormWindowInterface * formWindow() const override;
    static ::QDesignerFormWindowInterface * sbk_o_formWindow(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    bool hasSelection() const override;
    static bool sbk_o_hasSelection(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    bool movePosition(::QDesignerFormWindowCursorInterface::MoveOperation op, ::QDesignerFormWindowCursorInterface::MoveMode mode = QDesignerFormWindowCursorInterface::MoveMode::MoveAnchor) override;
    static bool sbk_o_movePosition(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QDesignerFormWindowCursorInterface::MoveOperation op, ::QDesignerFormWindowCursorInterface::MoveMode mode = QDesignerFormWindowCursorInterface::MoveMode::MoveAnchor);
    int position() const override;
    void resetWidgetProperty(::QWidget * widget, const ::QString & name) override;
    static void sbk_o_resetWidgetProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWidget * widget, const ::QString & name);
    ::QWidget * selectedWidget(int index) const override;
    static ::QWidget * sbk_o_selectedWidget(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int index);
    int selectedWidgetCount() const override;
    void setPosition(int pos, ::QDesignerFormWindowCursorInterface::MoveMode mode = QDesignerFormWindowCursorInterface::MoveMode::MoveAnchor) override;
    static void sbk_o_setPosition(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int pos, ::QDesignerFormWindowCursorInterface::MoveMode mode = QDesignerFormWindowCursorInterface::MoveMode::MoveAnchor);
    void setProperty(const ::QString & name, const ::QVariant & value) override;
    static void sbk_o_setProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & name, const ::QVariant & value);
    void setWidgetProperty(::QWidget * widget, const ::QString & name, const ::QVariant & value) override;
    static void sbk_o_setWidgetProperty(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWidget * widget, const ::QString & name, const ::QVariant & value);
    ::QWidget * widget(int index) const override;
    int widgetCount() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDESIGNERFORMWINDOWCURSORINTERFACEWRAPPER_H
