// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDESIGNERFORMWINDOWMANAGERINTERFACEWRAPPER_H
#define SBK_QDESIGNERFORMWINDOWMANAGERINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/abstractformwindowmanager.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QDesignerFormWindowManagerInterfaceWrapper : public QDesignerFormWindowManagerInterface
{
public:
    QDesignerFormWindowManagerInterfaceWrapper(::QObject * parent = nullptr);
    QDesignerFormWindowManagerInterfaceWrapper(const QDesignerFormWindowManagerInterfaceWrapper &) = delete;
    QDesignerFormWindowManagerInterfaceWrapper& operator=(const QDesignerFormWindowManagerInterfaceWrapper &) = delete;
    QDesignerFormWindowManagerInterfaceWrapper(QDesignerFormWindowManagerInterfaceWrapper &&) = delete;
    QDesignerFormWindowManagerInterfaceWrapper& operator=(QDesignerFormWindowManagerInterfaceWrapper &&) = delete;
    ~QDesignerFormWindowManagerInterfaceWrapper() override;

    ::QAction * action(::QDesignerFormWindowManagerInterface::Action action) const override;
    static ::QAction * sbk_o_action(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QDesignerFormWindowManagerInterface::Action action);
    ::QActionGroup * actionGroup(::QDesignerFormWindowManagerInterface::ActionGroup actionGroup) const override;
    static ::QActionGroup * sbk_o_actionGroup(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QDesignerFormWindowManagerInterface::ActionGroup actionGroup);
    ::QDesignerFormWindowInterface * activeFormWindow() const override;
    void addFormWindow(::QDesignerFormWindowInterface * formWindow) override;
    void childEvent(::QChildEvent * event) override;
    void closeAllPreviews() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QDesignerFormEditorInterface * core() const override;
    ::QDesignerFormWindowInterface * createFormWindow(::QWidget * parentWidget = nullptr, ::QFlags<Qt::WindowType> flags = Qt::WindowFlags()) override;
    static ::QDesignerFormWindowInterface * sbk_o_createFormWindow(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QWidget * parentWidget = nullptr, ::QFlags<Qt::WindowType> flags = Qt::WindowFlags());
    ::QPixmap createPreviewPixmap() const override;
    static ::QPixmap sbk_o_createPreviewPixmap(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void dragItems(const ::QList<QDesignerDnDItemInterface*> & item_list) override;
    static void sbk_o_dragItems(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QList<QDesignerDnDItemInterface*> & item_list);
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QDesignerFormWindowInterface * formWindow(int index) const override;
    static ::QDesignerFormWindowInterface * sbk_o_formWindow(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int index);
    int formWindowCount() const override;
    void removeFormWindow(::QDesignerFormWindowInterface * formWindow) override;
    void setActiveFormWindow(::QDesignerFormWindowInterface * formWindow) override;
    void showPluginDialog() override;
    void showPreview() override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[22] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDESIGNERFORMWINDOWMANAGERINTERFACEWRAPPER_H
