// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QEXTENSIONFACTORYWRAPPER_H
#define SBK_QEXTENSIONFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtDesigner/default_extensionfactory.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QExtensionFactoryWrapper : public QExtensionFactory
{
public:
    QExtensionFactoryWrapper(::QExtensionManager * parent = nullptr);
    QExtensionFactoryWrapper(const QExtensionFactoryWrapper &) = delete;
    QExtensionFactoryWrapper& operator=(const QExtensionFactoryWrapper &) = delete;
    QExtensionFactoryWrapper(QExtensionFactoryWrapper &&) = delete;
    QExtensionFactoryWrapper& operator=(QExtensionFactoryWrapper &&) = delete;
    ~QExtensionFactoryWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QObject * createExtension(::QObject * object, const ::QString & iid, ::QObject * parent) const override;
    static ::QObject * sbk_o_createExtension(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * object, const ::QString & iid, ::QObject * parent);
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QObject * extension(::QObject * object, const ::QString & iid) const override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QEXTENSIONFACTORYWRAPPER_H
