// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSPLINE3DSERIESWRAPPER_H
#define SBK_QSPLINE3DSERIESWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGraphs/qspline3dseries.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QSpline3DSeriesWrapper : public QSpline3DSeries
{
public:
    QSpline3DSeriesWrapper(::QObject * parent = nullptr);
    QSpline3DSeriesWrapper(::QScatterDataProxy * dataProxy, ::QObject * parent = nullptr);
    QSpline3DSeriesWrapper(const QSpline3DSeriesWrapper &) = delete;
    QSpline3DSeriesWrapper& operator=(const QSpline3DSeriesWrapper &) = delete;
    QSpline3DSeriesWrapper(QSpline3DSeriesWrapper &&) = delete;
    QSpline3DSeriesWrapper& operator=(QSpline3DSeriesWrapper &&) = delete;
    ~QSpline3DSeriesWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_QSPLINE3DSERIESWRAPPER_H
