// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_Q3DBARSWIDGETITEMWRAPPER_H
#define SBK_Q3DBARSWIDGETITEMWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGraphsWidgets/q3dbarswidgetitem.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class Q3DBarsWidgetItemWrapper : public Q3DBarsWidgetItem
{
public:
    Q3DBarsWidgetItemWrapper(::QObject * parent = nullptr);
    Q3DBarsWidgetItemWrapper(const Q3DBarsWidgetItemWrapper &) = delete;
    Q3DBarsWidgetItemWrapper& operator=(const Q3DBarsWidgetItemWrapper &) = delete;
    Q3DBarsWidgetItemWrapper(Q3DBarsWidgetItemWrapper &&) = delete;
    Q3DBarsWidgetItemWrapper& operator=(Q3DBarsWidgetItemWrapper &&) = delete;
    ~Q3DBarsWidgetItemWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * obj, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_Q3DBARSWIDGETITEMWRAPPER_H
