// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QABSTRACTFILEICONPROVIDERWRAPPER_H
#define SBK_QABSTRACTFILEICONPROVIDERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qabstractfileiconprovider.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAbstractFileIconProviderWrapper : public QAbstractFileIconProvider
{
public:
    QAbstractFileIconProviderWrapper();
    QAbstractFileIconProviderWrapper(const QAbstractFileIconProviderWrapper &) = delete;
    QAbstractFileIconProviderWrapper& operator=(const QAbstractFileIconProviderWrapper &) = delete;
    QAbstractFileIconProviderWrapper(QAbstractFileIconProviderWrapper &&) = delete;
    QAbstractFileIconProviderWrapper& operator=(QAbstractFileIconProviderWrapper &&) = delete;
    ~QAbstractFileIconProviderWrapper() override;

    ::QIcon icon(::QAbstractFileIconProvider::IconType arg__1) const override;
    static ::QIcon sbk_o_icon(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QAbstractFileIconProvider::IconType arg__1);
    ::QIcon icon(const ::QFileInfo & arg__1) const override;
    static ::QIcon sbk_o_icon(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QFileInfo & arg__1);
    ::QFlags<QAbstractFileIconProvider::Option> options() const override;
    static ::QFlags<QAbstractFileIconProvider::Option> sbk_o_options(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setOptions(::QFlags<QAbstractFileIconProvider::Option> arg__1) override;
    static void sbk_o_setOptions(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QFlags<QAbstractFileIconProvider::Option> arg__1);
    ::QString type(const ::QFileInfo & arg__1) const override;
    static ::QString sbk_o_type(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QFileInfo & arg__1);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QABSTRACTFILEICONPROVIDERWRAPPER_H
