// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLEATTRIBUTESINTERFACEWRAPPER_H
#define SBK_QACCESSIBLEATTRIBUTESINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleAttributesInterfaceWrapper : public QAccessibleAttributesInterface
{
public:
    QAccessibleAttributesInterfaceWrapper();
    QAccessibleAttributesInterfaceWrapper(const QAccessibleAttributesInterfaceWrapper &) = delete;
    QAccessibleAttributesInterfaceWrapper& operator=(const QAccessibleAttributesInterfaceWrapper &) = delete;
    QAccessibleAttributesInterfaceWrapper(QAccessibleAttributesInterfaceWrapper &&) = delete;
    QAccessibleAttributesInterfaceWrapper& operator=(QAccessibleAttributesInterfaceWrapper &&) = delete;
    ~QAccessibleAttributesInterfaceWrapper() override;

    ::QList<QAccessible::Attribute> attributeKeys() const override;
    static ::QList<QAccessible::Attribute> sbk_o_attributeKeys(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QVariant attributeValue(::QAccessible::Attribute key) const override;
    static ::QVariant sbk_o_attributeValue(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QAccessible::Attribute key);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QACCESSIBLEATTRIBUTESINTERFACEWRAPPER_H
