// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLEEDITABLETEXTINTERFACEWRAPPER_H
#define SBK_QACCESSIBLEEDITABLETEXTINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleEditableTextInterfaceWrapper : public QAccessibleEditableTextInterface
{
public:
    QAccessibleEditableTextInterfaceWrapper();
    QAccessibleEditableTextInterfaceWrapper(const QAccessibleEditableTextInterfaceWrapper &) = delete;
    QAccessibleEditableTextInterfaceWrapper& operator=(const QAccessibleEditableTextInterfaceWrapper &) = delete;
    QAccessibleEditableTextInterfaceWrapper(QAccessibleEditableTextInterfaceWrapper &&) = delete;
    QAccessibleEditableTextInterfaceWrapper& operator=(QAccessibleEditableTextInterfaceWrapper &&) = delete;
    ~QAccessibleEditableTextInterfaceWrapper() override;

    void deleteText(int startOffset, int endOffset) override;
    void insertText(int offset, const ::QString & text) override;
    static void sbk_o_insertText(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int offset, const ::QString & text);
    void replaceText(int startOffset, int endOffset, const ::QString & text) override;
    static void sbk_o_replaceText(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int startOffset, int endOffset, const ::QString & text);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QACCESSIBLEEDITABLETEXTINTERFACEWRAPPER_H
