// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCESSIBLEVALUEINTERFACEWRAPPER_H
#define SBK_QACCESSIBLEVALUEINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qaccessible.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccessibleValueInterfaceWrapper : public QAccessibleValueInterface
{
public:
    QAccessibleValueInterfaceWrapper();
    QAccessibleValueInterfaceWrapper(const QAccessibleValueInterfaceWrapper &) = delete;
    QAccessibleValueInterfaceWrapper& operator=(const QAccessibleValueInterfaceWrapper &) = delete;
    QAccessibleValueInterfaceWrapper(QAccessibleValueInterfaceWrapper &&) = delete;
    QAccessibleValueInterfaceWrapper& operator=(QAccessibleValueInterfaceWrapper &&) = delete;
    ~QAccessibleValueInterfaceWrapper() override;

    ::QVariant currentValue() const override;
    static ::QVariant sbk_o_currentValue(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QVariant maximumValue() const override;
    ::QVariant minimumStepSize() const override;
    ::QVariant minimumValue() const override;
    void setCurrentValue(const ::QVariant & value) override;
    static void sbk_o_setCurrentValue(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QVariant & value);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QACCESSIBLEVALUEINTERFACEWRAPPER_H
