// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACTIONEVENTWRAPPER_H
#define SBK_QACTIONEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QActionEventWrapper : public QActionEvent
{
public:
    QActionEventWrapper(int type, ::QAction * action, ::QAction * before = nullptr);
    QActionEventWrapper(const QActionEventWrapper &) = delete;
    QActionEventWrapper(const QActionEvent& self) : QActionEvent(self)
    {
    }
    QActionEventWrapper& operator=(const QActionEventWrapper &) = delete;
    QActionEventWrapper(QActionEventWrapper &&) = delete;
    QActionEventWrapper& operator=(QActionEventWrapper &&) = delete;
    ~QActionEventWrapper() override;

    ::QActionEvent * clone() const override;
    static ::QActionEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QACTIONEVENTWRAPPER_H
