// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QBITMAPWRAPPER_H
#define SBK_QBITMAPWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qbitmap.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QBitmapWrapper : public QBitmap
{
public:
    QBitmapWrapper();
    QBitmapWrapper(const ::QPixmap & arg__1);
    QBitmapWrapper(const ::QSize & arg__1);
    QBitmapWrapper(const ::QString & fileName, const char * format = nullptr);
    QBitmapWrapper(int w, int h);
    QBitmapWrapper(const QBitmapWrapper &) = delete;
    QBitmapWrapper(const QBitmap& self) : QBitmap(self)
    {
    }
    QBitmapWrapper& operator=(const QBitmapWrapper &) = delete;
    QBitmapWrapper(QBitmapWrapper &&) = delete;
    QBitmapWrapper& operator=(QBitmapWrapper &&) = delete;
    ~QBitmapWrapper() override;

    int devType() const override;
    void initPainter(::QPainter * painter) const override;
    int metric(::QPaintDevice::PaintDeviceMetric arg__1) const override;
    ::QPaintEngine * paintEngine() const override;
    ::QPaintDevice * redirected(::QPoint * offset) const override;
    ::QPainter * sharedPainter() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QBITMAPWRAPPER_H
