// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCONTEXTMENUEVENTWRAPPER_H
#define SBK_QCONTEXTMENUEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QContextMenuEventWrapper : public QContextMenuEvent
{
public:
    QContextMenuEventWrapper(::QContextMenuEvent::Reason reason, const ::QPoint & pos);
    QContextMenuEventWrapper(::QContextMenuEvent::Reason reason, const ::QPoint & pos, const ::QPoint & globalPos, ::QFlags<Qt::KeyboardModifier> modifiers = Qt::NoModifier);
    QContextMenuEventWrapper(const QContextMenuEventWrapper &) = delete;
    QContextMenuEventWrapper(const QContextMenuEvent& self) : QContextMenuEvent(self)
    {
    }
    QContextMenuEventWrapper& operator=(const QContextMenuEventWrapper &) = delete;
    QContextMenuEventWrapper(QContextMenuEventWrapper &&) = delete;
    QContextMenuEventWrapper& operator=(QContextMenuEventWrapper &&) = delete;
    ~QContextMenuEventWrapper() override;

    ::QContextMenuEvent * clone() const override;
    static ::QContextMenuEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    void setTimestamp(quint64 timestamp) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QCONTEXTMENUEVENTWRAPPER_H
