// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDOUBLEVALIDATORWRAPPER_H
#define SBK_QDOUBLEVALIDATORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qvalidator.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QDoubleValidatorWrapper : public QDoubleValidator
{
public:
    QDoubleValidatorWrapper(::QObject * parent = nullptr);
    QDoubleValidatorWrapper(double bottom, double top, int decimals, ::QObject * parent = nullptr);
    QDoubleValidatorWrapper(const QDoubleValidatorWrapper &) = delete;
    QDoubleValidatorWrapper& operator=(const QDoubleValidatorWrapper &) = delete;
    QDoubleValidatorWrapper(QDoubleValidatorWrapper &&) = delete;
    QDoubleValidatorWrapper& operator=(QDoubleValidatorWrapper &&) = delete;
    ~QDoubleValidatorWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void fixup(::QString & input) const override;
    void timerEvent(::QTimerEvent * event) override;
    ::QValidator::State validate(::QString & arg__1, int & arg__2) const override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QDOUBLEVALIDATORWRAPPER_H
