// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QDRAGLEAVEEVENTWRAPPER_H
#define SBK_QDRAGLEAVEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QDragLeaveEventWrapper : public QDragLeaveEvent
{
public:
    QDragLeaveEventWrapper();
    QDragLeaveEventWrapper(const QDragLeaveEventWrapper &) = delete;
    QDragLeaveEventWrapper(const QDragLeaveEvent& self) : QDragLeaveEvent(self)
    {
    }
    QDragLeaveEventWrapper& operator=(const QDragLeaveEventWrapper &) = delete;
    QDragLeaveEventWrapper(QDragLeaveEventWrapper &&) = delete;
    QDragLeaveEventWrapper& operator=(QDragLeaveEventWrapper &&) = delete;
    ~QDragLeaveEventWrapper() override;

    ::QDragLeaveEvent * clone() const override;
    static ::QDragLeaveEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QDRAGLEAVEEVENTWRAPPER_H
