// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QFOCUSEVENTWRAPPER_H
#define SBK_QFOCUSEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QFocusEventWrapper : public QFocusEvent
{
public:
    QFocusEventWrapper(::QEvent::Type type, ::Qt::FocusReason reason = Qt::OtherFocusReason);
    QFocusEventWrapper(const QFocusEventWrapper &) = delete;
    QFocusEventWrapper(const QFocusEvent& self) : QFocusEvent(self)
    {
    }
    QFocusEventWrapper& operator=(const QFocusEventWrapper &) = delete;
    QFocusEventWrapper(QFocusEventWrapper &&) = delete;
    QFocusEventWrapper& operator=(QFocusEventWrapper &&) = delete;
    ~QFocusEventWrapper() override;

    ::QFocusEvent * clone() const override;
    static ::QFocusEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QFOCUSEVENTWRAPPER_H
