// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QHIDEEVENTWRAPPER_H
#define SBK_QHIDEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QHideEventWrapper : public QHideEvent
{
public:
    QHideEventWrapper();
    QHideEventWrapper(const QHideEventWrapper &) = delete;
    QHideEventWrapper(const QHideEvent& self) : QHideEvent(self)
    {
    }
    QHideEventWrapper& operator=(const QHideEventWrapper &) = delete;
    QHideEventWrapper(QHideEventWrapper &&) = delete;
    QHideEventWrapper& operator=(QHideEventWrapper &&) = delete;
    ~QHideEventWrapper() override;

    ::QHideEvent * clone() const override;
    static ::QHideEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QHIDEEVENTWRAPPER_H
