// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QICONDRAGEVENTWRAPPER_H
#define SBK_QICONDRAGEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QIconDragEventWrapper : public QIconDragEvent
{
public:
    QIconDragEventWrapper();
    QIconDragEventWrapper(const QIconDragEventWrapper &) = delete;
    QIconDragEventWrapper(const QIconDragEvent& self) : QIconDragEvent(self)
    {
    }
    QIconDragEventWrapper& operator=(const QIconDragEventWrapper &) = delete;
    QIconDragEventWrapper(QIconDragEventWrapper &&) = delete;
    QIconDragEventWrapper& operator=(QIconDragEventWrapper &&) = delete;
    ~QIconDragEventWrapper() override;

    ::QIconDragEvent * clone() const override;
    static ::QIconDragEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QICONDRAGEVENTWRAPPER_H
