// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QINPUTMETHODEVENTWRAPPER_H
#define SBK_QINPUTMETHODEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QInputMethodEventWrapper : public QInputMethodEvent
{
public:
    QInputMethodEventWrapper();
    QInputMethodEventWrapper(const ::QString & preeditText, const ::QList<QInputMethodEvent::Attribute> & attributes);
    QInputMethodEventWrapper(const QInputMethodEventWrapper &) = delete;
    QInputMethodEventWrapper(const QInputMethodEvent& self) : QInputMethodEvent(self)
    {
    }
    QInputMethodEventWrapper& operator=(const QInputMethodEventWrapper &) = delete;
    QInputMethodEventWrapper(QInputMethodEventWrapper &&) = delete;
    QInputMethodEventWrapper& operator=(QInputMethodEventWrapper &&) = delete;
    ~QInputMethodEventWrapper() override;

    ::QInputMethodEvent * clone() const override;
    static ::QInputMethodEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QINPUTMETHODEVENTWRAPPER_H
