// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRESIZEEVENTWRAPPER_H
#define SBK_QRESIZEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QResizeEventWrapper : public QResizeEvent
{
public:
    QResizeEventWrapper(const ::QSize & size, const ::QSize & oldSize);
    QResizeEventWrapper(const QResizeEventWrapper &) = delete;
    QResizeEventWrapper(const QResizeEvent& self) : QResizeEvent(self)
    {
    }
    QResizeEventWrapper& operator=(const QResizeEventWrapper &) = delete;
    QResizeEventWrapper(QResizeEventWrapper &&) = delete;
    QResizeEventWrapper& operator=(QResizeEventWrapper &&) = delete;
    ~QResizeEventWrapper() override;

    ::QResizeEvent * clone() const override;
    static ::QResizeEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QRESIZEEVENTWRAPPER_H
