// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHIBUFFERWRAPPER_H
#define SBK_QRHIBUFFERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRhiBufferWrapper : public QRhiBuffer
{
public:
    QRhiBufferWrapper(const QRhiBufferWrapper &) = delete;
    QRhiBufferWrapper& operator=(const QRhiBufferWrapper &) = delete;
    QRhiBufferWrapper(QRhiBufferWrapper &&) = delete;
    QRhiBufferWrapper& operator=(QRhiBufferWrapper &&) = delete;
    ~QRhiBufferWrapper() override;

    bool create() override;
    void destroy() override;
    void endFullDynamicBufferUpdateForCurrentFrame() override;
    void fullDynamicBufferUpdateForCurrentFrame(const void * data, quint32 size = 0) override;
    static void sbk_o_fullDynamicBufferUpdateForCurrentFrame(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const void * data, quint32 size = 0);
    ::QRhiResource::Type resourceType() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[5] = {false, false, false, false, false};
};

#endif // SBK_QRHIBUFFERWRAPPER_H
