// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtgui_python.h"
#include "pyside6_qtgui_python_p.h"

// main header
#include "qrhitextureuploaddescription_wrapper.h"

// Argument includes
#include <QList>
#include <rhi/qrhi.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QRhiTextureUploadDescription_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QRhiTextureUploadDescription >()))
        return -1;

    ::QRhiTextureUploadDescription *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QRhiTextureUploadDescription", 0, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QRhiTextureUploadDescription::QRhiTextureUploadDescription()
    // 1: QRhiTextureUploadDescription::QRhiTextureUploadDescription(QRhiTextureUploadDescription)
    // 2: QRhiTextureUploadDescription::QRhiTextureUploadDescription(QRhiTextureUploadEntry)
    if (numArgs == 0) {
        overloadId = 0; // QRhiTextureUploadDescription()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), (pyArgs[0])))) {
        overloadId = 2; // QRhiTextureUploadDescription(QRhiTextureUploadEntry)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), (pyArgs[0])))) {
        overloadId = 1; // QRhiTextureUploadDescription(QRhiTextureUploadDescription)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    switch (overloadId) {
        case 0: // QRhiTextureUploadDescription()
        {

            // QRhiTextureUploadDescription()
            cptr = new ::QRhiTextureUploadDescription();
            break;
        }
        case 1: // QRhiTextureUploadDescription(const QRhiTextureUploadDescription &QRhiTextureUploadDescription)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureUploadDescription cppArg0_local;
            ::QRhiTextureUploadDescription *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadDescription(QRhiTextureUploadDescription)
                cptr = new ::QRhiTextureUploadDescription(*cppArg0);
            }
            break;
        }
        case 2: // QRhiTextureUploadDescription(const QRhiTextureUploadEntry &entry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QRhiTextureUploadEntry cppArg0_local;
            ::QRhiTextureUploadEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (Shiboken::Errors::occurred() == nullptr) {
                // QRhiTextureUploadDescription(QRhiTextureUploadEntry)
                cptr = new ::QRhiTextureUploadDescription(*cppArg0);
            }
            break;
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QRhiTextureUploadDescription >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_cbeginEntries(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // cbeginEntries()const
        const QRhiTextureUploadEntry * cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->cbeginEntries();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_cendEntries(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // cendEntries()const
        const QRhiTextureUploadEntry * cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->cendEntries();
        pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_entryAt(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadDescription::entryAt(qsizetype)const->const QRhiTextureUploadEntry*
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), (pyArg)))) {
        overloadId = 0; // entryAt(qsizetype)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "entryAt", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]);

    // Call function/method
    {
        qsizetype cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // entryAt(qsizetype)const
            const QRhiTextureUploadEntry * cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->entryAt(cppArg0);
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), cppResult);
        }
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_entryCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        // entryCount()const
        qsizetype cppResult = const_cast<const ::QRhiTextureUploadDescription *>(cppSelf)->entryCount();
        pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<qsizetype>(), &cppResult);
    }

    return Sbk_ReturnFromPython_Result(pyResult);
}

static PyObject *Sbk_QRhiTextureUploadDescriptionFunc_setEntries(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QRhiTextureUploadDescription::setEntries(QList<QRhiTextureUploadEntry>)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtGuiTypeConverters[SBK_QtGui_QList_QRhiTextureUploadEntry_IDX], (pyArg)))) {
        overloadId = 0; // setEntries(QList<QRhiTextureUploadEntry>)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "setEntries", errInfo, SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]);

    // Call function/method
    {
        ::QList<QRhiTextureUploadEntry> cppArg0;
        pythonToCpp(pyArg, &cppArg0);
        SBK_UNUSED(cppArg0)

        if (Shiboken::Errors::occurred() == nullptr) {
            // setEntries(QList<QRhiTextureUploadEntry>)
            // Begin code injection
            // ========================================================================
            // START of custom code block [file: ../glue/qtgui.cpp (qrhi-initializer-list)]
            cppSelf->setEntries(cppArg0.cbegin(), cppArg0.cend());
            // END of custom code block [file: ../glue/qtgui.cpp (qrhi-initializer-list)]
            // ========================================================================
            // End of code injection

        }
    }

     return Sbk_ReturnFromPython_None();
}

static PyObject *Sbk_QRhiTextureUploadDescription__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QRhiTextureUploadDescription_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QRhiTextureUploadDescription_methods[] = {
    {"cbeginEntries", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_cbeginEntries), METH_NOARGS, nullptr},
    {"cendEntries", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_cendEntries), METH_NOARGS, nullptr},
    {"entryAt", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_entryAt), METH_O, nullptr},
    {"entryCount", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_entryCount), METH_NOARGS, nullptr},
    {"setEntries", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescriptionFunc_setEntries), METH_O, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QRhiTextureUploadDescription__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QRhiTextureUploadDescription_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QRhiTextureUploadDescription_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QRhiTextureUploadDescription_Type = nullptr;
static PyTypeObject *Sbk_QRhiTextureUploadDescription_TypeF(void)
{
    return _Sbk_QRhiTextureUploadDescription_Type;
}

static PyType_Slot Sbk_QRhiTextureUploadDescription_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QRhiTextureUploadDescription_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QRhiTextureUploadDescription_spec = {
    "2:PySide6.QtGui.QRhiTextureUploadDescription",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QRhiTextureUploadDescription_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QRhiTextureUploadDescription_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadDescription_TypeF()))
        return QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QRhiTextureUploadDescription_PTR_CppToPython_QRhiTextureUploadDescription(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QRhiTextureUploadDescription_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QRhiTextureUploadDescription_COPY_CppToPython_QRhiTextureUploadDescription(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QRhiTextureUploadDescription *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QRhiTextureUploadDescription_TypeF(), new ::QRhiTextureUploadDescription(*source), true, true);
}

// Python to C++ copy conversion.
static void QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureUploadDescription *>(cppOut) = *reinterpret_cast< ::QRhiTextureUploadDescription *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QRhiTextureUploadDescription_TypeF()))
        return QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY;
    return {};
}

// Implicit conversions.
static void constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QRhiTextureUploadDescription *>(cppOut) = ::QRhiTextureUploadDescription( *reinterpret_cast< ::QRhiTextureUploadEntry *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), reinterpret_cast<SbkObject *>(pyIn))));
}
static PythonToCppFunc is_constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription_Convertible(PyObject *pyIn)
{
    if (SbkObject_TypeCheck(Shiboken::Module::get(SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadEntry_IDX]), pyIn))
        return constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QRhiTextureUploadDescription_SignatureStrings[] = {
    "2:PySide6.QtGui.QRhiTextureUploadDescription(self)",
    "1:PySide6.QtGui.QRhiTextureUploadDescription(self,QRhiTextureUploadDescription:PySide6.QtGui.QRhiTextureUploadDescription)",
    "0:PySide6.QtGui.QRhiTextureUploadDescription(self,entry:PySide6.QtGui.QRhiTextureUploadEntry)",
    "PySide6.QtGui.QRhiTextureUploadDescription.cbeginEntries(self)->PySide6.QtGui.QRhiTextureUploadEntry",
    "PySide6.QtGui.QRhiTextureUploadDescription.cendEntries(self)->PySide6.QtGui.QRhiTextureUploadEntry",
    "PySide6.QtGui.QRhiTextureUploadDescription.entryAt(self,index:qsizetype)->PySide6.QtGui.QRhiTextureUploadEntry",
    "PySide6.QtGui.QRhiTextureUploadDescription.entryCount(self)->qsizetype",
    "PySide6.QtGui.QRhiTextureUploadDescription.setEntries(self,entries:QList[PySide6.QtGui.QRhiTextureUploadEntry])",
    "PySide6.QtGui.QRhiTextureUploadDescription.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QRhiTextureUploadDescription_SignatureByteSize = 191;
static constexpr uint8_t QRhiTextureUploadDescription_SignatureBytes[191] = {
    0x78, 0xda, 0xb5, 0x91, 0x3f, 0x0b, 0xc2, 0x30, 0x10, 0xc5, 0xf7, 0x7c, 0x12, 0x0b, 0x1a, 0xd4,
    0xc1, 0xa1, 0x83, 0x20, 0x2a, 0x2e, 0x0e, 0xd6, 0xea, 0x24, 0x12, 0xb4, 0x39, 0xeb, 0x41, 0x49,
    0x62, 0x73, 0x85, 0xc6, 0x4f, 0x6f, 0xff, 0x50, 0x71, 0xd2, 0x66, 0x70, 0x3c, 0xb8, 0xf7, 0x7e,
    0xef, 0xde, 0x4d, 0xc3, 0x9d, 0x8b, 0x51, 0xc2, 0x8c, 0x47, 0xb4, 0x29, 0x90, 0x47, 0xfb, 0x3b,
    0x1e, 0xa0, 0xa4, 0x22, 0x87, 0xa3, 0xc9, 0xf4, 0x45, 0xae, 0xc0, 0x26, 0x39, 0x1a, 0x42, 0xad,
    0x06, 0x16, 0xb2, 0x5b, 0xc0, 0x26, 0xbe, 0x92, 0xe1, 0xb7, 0x0d, 0x0f, 0xb3, 0x80, 0x8d, 0xbd,
    0xd1, 0xa0, 0x28, 0x77, 0xbf, 0x54, 0xeb, 0x7a, 0x29, 0x60, 0xfd, 0xbd, 0x79, 0x72, 0x85, 0x14,
    0x55, 0xad, 0x43, 0xb0, 0x6d, 0x2f, 0xa3, 0x79, 0x1f, 0x8a, 0x17, 0x04, 0x94, 0xfc, 0x33, 0xa2,
    0xa9, 0x67, 0x41, 0x6d, 0x57, 0xa8, 0x24, 0x94, 0xe1, 0xc3, 0xe2, 0x13, 0xc8, 0x19, 0xf8, 0x17,
    0x6e, 0xa9, 0x0b, 0x45, 0xdd, 0x41, 0x6f, 0x9a, 0x8f, 0x8d, 0x05, 0xfa, 0xec, 0xa5, 0x79, 0x72,
    0x35, 0x84, 0xd1, 0x16, 0x2d, 0x9d, 0xfa, 0x84, 0x3e, 0x7b, 0x7d, 0x5b, 0x88, 0x44, 0x1b, 0x27,
    0x44, 0x17, 0xba, 0xca, 0x8b, 0x2a, 0xe5, 0x71, 0x35, 0xb1, 0x17, 0xb2, 0xad, 0x37, 0x0a
};
#endif

PyTypeObject *init_QRhiTextureUploadDescription(PyObject *module)
{
    if (SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX].type != nullptr)
        return SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX].type;

    Shiboken::AutoDecRef Sbk_QRhiTextureUploadDescription_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QRhiTextureUploadDescription_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QRhiTextureUploadDescription",
        "QRhiTextureUploadDescription",
        &Sbk_QRhiTextureUploadDescription_spec,
        &Shiboken::callCppDestructor< ::QRhiTextureUploadDescription >,
        Sbk_QRhiTextureUploadDescription_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QRhiTextureUploadDescription_TypeF(); // references _Sbk_QRhiTextureUploadDescription_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QRhiTextureUploadDescription_SignatureStrings);
#else
    InitSignatureBytes(pyType, QRhiTextureUploadDescription_SignatureBytes, QRhiTextureUploadDescription_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QRhiTextureUploadDescription_PropertyStrings);
    SbkPySide6_QtGuiTypeStructs[SBK_QRhiTextureUploadDescription_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR,
        is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_PTR_Convertible,
        QRhiTextureUploadDescription_PTR_CppToPython_QRhiTextureUploadDescription,
        QRhiTextureUploadDescription_COPY_CppToPython_QRhiTextureUploadDescription);

    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadDescription");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadDescription*");
    Shiboken::Conversions::registerConverterName(converter, "QRhiTextureUploadDescription&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QRhiTextureUploadDescription).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY,
        is_QRhiTextureUploadDescription_PythonToCpp_QRhiTextureUploadDescription_COPY_Convertible);
    // Add implicit conversions to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription,
        is_constQRhiTextureUploadEntryREF_PythonToCpp_QRhiTextureUploadDescription_Convertible);

    qRegisterMetaType< ::QRhiTextureUploadDescription >("QRhiTextureUploadDescription");

    return pyType;
}
