// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSHORTCUTEVENTWRAPPER_H
#define SBK_QSHORTCUTEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QShortcutEventWrapper : public QShortcutEvent
{
public:
    QShortcutEventWrapper(const ::QKeySequence & key, const ::QShortcut * shortcut = nullptr, bool ambiguous = false);
    QShortcutEventWrapper(const ::QKeySequence & key, int id, bool ambiguous = false);
    QShortcutEventWrapper(const QShortcutEventWrapper &) = delete;
    QShortcutEventWrapper(const QShortcutEvent& self) : QShortcutEvent(self)
    {
    }
    QShortcutEventWrapper& operator=(const QShortcutEventWrapper &) = delete;
    QShortcutEventWrapper(QShortcutEventWrapper &&) = delete;
    QShortcutEventWrapper& operator=(QShortcutEventWrapper &&) = delete;
    ~QShortcutEventWrapper() override;

    ::QShortcutEvent * clone() const override;
    static ::QShortcutEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSHORTCUTEVENTWRAPPER_H
