// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSHOWEVENTWRAPPER_H
#define SBK_QSHOWEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QShowEventWrapper : public QShowEvent
{
public:
    QShowEventWrapper();
    QShowEventWrapper(const QShowEventWrapper &) = delete;
    QShowEventWrapper(const QShowEvent& self) : QShowEvent(self)
    {
    }
    QShowEventWrapper& operator=(const QShowEventWrapper &) = delete;
    QShowEventWrapper(QShowEventWrapper &&) = delete;
    QShowEventWrapper& operator=(QShowEventWrapper &&) = delete;
    ~QShowEventWrapper() override;

    ::QShowEvent * clone() const override;
    static ::QShowEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSHOWEVENTWRAPPER_H
