// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWHATSTHISCLICKEDEVENTWRAPPER_H
#define SBK_QWHATSTHISCLICKEDEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtGui/qevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QWhatsThisClickedEventWrapper : public QWhatsThisClickedEvent
{
public:
    QWhatsThisClickedEventWrapper(const ::QString & href);
    QWhatsThisClickedEventWrapper(const QWhatsThisClickedEventWrapper &) = delete;
    QWhatsThisClickedEventWrapper(const QWhatsThisClickedEvent& self) : QWhatsThisClickedEvent(self)
    {
    }
    QWhatsThisClickedEventWrapper& operator=(const QWhatsThisClickedEventWrapper &) = delete;
    QWhatsThisClickedEventWrapper(QWhatsThisClickedEventWrapper &&) = delete;
    QWhatsThisClickedEventWrapper& operator=(QWhatsThisClickedEventWrapper &&) = delete;
    ~QWhatsThisClickedEventWrapper() override;

    ::QWhatsThisClickedEvent * clone() const override;
    static ::QWhatsThisClickedEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QWHATSTHISCLICKEDEVENTWRAPPER_H
