// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGEOCODINGMANAGERENGINEWRAPPER_H
#define SBK_QGEOCODINGMANAGERENGINEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qgeocodingmanagerengine.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QGeoCodingManagerEngineWrapper : public QGeoCodingManagerEngine
{
public:
    QGeoCodingManagerEngineWrapper(const ::QMap<QString,QVariant> & parameters, ::QObject * parent = nullptr);
    QGeoCodingManagerEngineWrapper(const QGeoCodingManagerEngineWrapper &) = delete;
    QGeoCodingManagerEngineWrapper& operator=(const QGeoCodingManagerEngineWrapper &) = delete;
    QGeoCodingManagerEngineWrapper(QGeoCodingManagerEngineWrapper &&) = delete;
    QGeoCodingManagerEngineWrapper& operator=(QGeoCodingManagerEngineWrapper &&) = delete;
    ~QGeoCodingManagerEngineWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QGeoCodeReply * geocode(const ::QGeoAddress & address, const ::QGeoShape & bounds) override;
    static ::QGeoCodeReply * sbk_o_geocode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QGeoAddress & address, const ::QGeoShape & bounds);
    ::QGeoCodeReply * geocode(const ::QString & address, int limit, int offset, const ::QGeoShape & bounds) override;
    static ::QGeoCodeReply * sbk_o_geocode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & address, int limit, int offset, const ::QGeoShape & bounds);
    ::QGeoCodeReply * reverseGeocode(const ::QGeoCoordinate & coordinate, const ::QGeoShape & bounds) override;
    static ::QGeoCodeReply * sbk_o_reverseGeocode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QGeoCoordinate & coordinate, const ::QGeoShape & bounds);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QGEOCODINGMANAGERENGINEWRAPPER_H
