// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QPLACESEARCHRESULTWRAPPER_H
#define SBK_QPLACESEARCHRESULTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtLocation/qplacesearchresult.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QPlaceSearchResultWrapper : public QPlaceSearchResult
{
public:
    QPlaceSearchResultWrapper();
    QPlaceSearchResultWrapper(const QPlaceSearchResultWrapper &) = delete;
    QPlaceSearchResultWrapper(const QPlaceSearchResult& self) : QPlaceSearchResult(self)
    {
    }
    QPlaceSearchResultWrapper& operator=(const QPlaceSearchResultWrapper &) = delete;
    QPlaceSearchResultWrapper(QPlaceSearchResultWrapper &&) = delete;
    QPlaceSearchResultWrapper& operator=(QPlaceSearchResultWrapper &&) = delete;
    ~QPlaceSearchResultWrapper() override;

    static void pysideInitQtMetaTypes();

private:
};

#endif // SBK_QPLACESEARCHRESULTWRAPPER_H
