// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOPENGLFRAMEBUFFEROBJECTWRAPPER_H
#define SBK_QOPENGLFRAMEBUFFEROBJECTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglframebufferobject.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QOpenGLFramebufferObjectWrapper : public QOpenGLFramebufferObject
{
public:
    QOpenGLFramebufferObjectWrapper(const ::QSize & size, ::QOpenGLFramebufferObject::Attachment attachment, unsigned int target = GL_TEXTURE_2D, unsigned int internalFormat = 0);
    QOpenGLFramebufferObjectWrapper(const ::QSize & size, const ::QOpenGLFramebufferObjectFormat & format);
    QOpenGLFramebufferObjectWrapper(const ::QSize & size, unsigned int target = GL_TEXTURE_2D);
    QOpenGLFramebufferObjectWrapper(int width, int height, ::QOpenGLFramebufferObject::Attachment attachment, unsigned int target = GL_TEXTURE_2D, unsigned int internalFormat = 0);
    QOpenGLFramebufferObjectWrapper(int width, int height, const ::QOpenGLFramebufferObjectFormat & format);
    QOpenGLFramebufferObjectWrapper(int width, int height, unsigned int target = GL_TEXTURE_2D);
    QOpenGLFramebufferObjectWrapper(const QOpenGLFramebufferObjectWrapper &) = delete;
    QOpenGLFramebufferObjectWrapper& operator=(const QOpenGLFramebufferObjectWrapper &) = delete;
    QOpenGLFramebufferObjectWrapper(QOpenGLFramebufferObjectWrapper &&) = delete;
    QOpenGLFramebufferObjectWrapper& operator=(QOpenGLFramebufferObjectWrapper &&) = delete;
    ~QOpenGLFramebufferObjectWrapper() override;

    static void pysideInitQtMetaTypes();

private:
};

#endif // SBK_QOPENGLFRAMEBUFFEROBJECTWRAPPER_H
