// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOPENGLFUNCTIONS_1_5WRAPPER_H
#define SBK_QOPENGLFUNCTIONS_1_5WRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_1_5.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QOpenGLFunctions_1_5Wrapper : public QOpenGLFunctions_1_5
{
public:
    QOpenGLFunctions_1_5Wrapper();
    QOpenGLFunctions_1_5Wrapper(const QOpenGLFunctions_1_5Wrapper &) = delete;
    QOpenGLFunctions_1_5Wrapper& operator=(const QOpenGLFunctions_1_5Wrapper &) = delete;
    QOpenGLFunctions_1_5Wrapper(QOpenGLFunctions_1_5Wrapper &&) = delete;
    QOpenGLFunctions_1_5Wrapper& operator=(QOpenGLFunctions_1_5Wrapper &&) = delete;
    ~QOpenGLFunctions_1_5Wrapper() override;

    bool initializeOpenGLFunctions() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOPENGLFUNCTIONS_1_5WRAPPER_H
