// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOPENGLFUNCTIONS_3_1WRAPPER_H
#define SBK_QOPENGLFUNCTIONS_3_1WRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_3_1.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QOpenGLFunctions_3_1Wrapper : public QOpenGLFunctions_3_1
{
public:
    QOpenGLFunctions_3_1Wrapper();
    QOpenGLFunctions_3_1Wrapper(const QOpenGLFunctions_3_1Wrapper &) = delete;
    QOpenGLFunctions_3_1Wrapper& operator=(const QOpenGLFunctions_3_1Wrapper &) = delete;
    QOpenGLFunctions_3_1Wrapper(QOpenGLFunctions_3_1Wrapper &&) = delete;
    QOpenGLFunctions_3_1Wrapper& operator=(QOpenGLFunctions_3_1Wrapper &&) = delete;
    ~QOpenGLFunctions_3_1Wrapper() override;

    bool initializeOpenGLFunctions() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOPENGLFUNCTIONS_3_1WRAPPER_H
