// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QOPENGLFUNCTIONS_3_3_COMPATIBILITYWRAPPER_H
#define SBK_QOPENGLFUNCTIONS_3_3_COMPATIBILITYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtOpenGL/qopenglfunctions_3_3_compatibility.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QOpenGLFunctions_3_3_CompatibilityWrapper : public QOpenGLFunctions_3_3_Compatibility
{
public:
    QOpenGLFunctions_3_3_CompatibilityWrapper();
    QOpenGLFunctions_3_3_CompatibilityWrapper(const QOpenGLFunctions_3_3_CompatibilityWrapper &) = delete;
    QOpenGLFunctions_3_3_CompatibilityWrapper& operator=(const QOpenGLFunctions_3_3_CompatibilityWrapper &) = delete;
    QOpenGLFunctions_3_3_CompatibilityWrapper(QOpenGLFunctions_3_3_CompatibilityWrapper &&) = delete;
    QOpenGLFunctions_3_3_CompatibilityWrapper& operator=(QOpenGLFunctions_3_3_CompatibilityWrapper &&) = delete;
    ~QOpenGLFunctions_3_3_CompatibilityWrapper() override;

    bool initializeOpenGLFunctions() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QOPENGLFUNCTIONS_3_3_COMPATIBILITYWRAPPER_H
