// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGEOPOSITIONINFOSOURCEFACTORYWRAPPER_H
#define SBK_QGEOPOSITIONINFOSOURCEFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtPositioning/qgeopositioninfosourcefactory.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGeoPositionInfoSourceFactoryWrapper : public QGeoPositionInfoSourceFactory
{
public:
    QGeoPositionInfoSourceFactoryWrapper();
    QGeoPositionInfoSourceFactoryWrapper(const QGeoPositionInfoSourceFactoryWrapper &) = delete;
    QGeoPositionInfoSourceFactoryWrapper& operator=(const QGeoPositionInfoSourceFactoryWrapper &) = delete;
    QGeoPositionInfoSourceFactoryWrapper(QGeoPositionInfoSourceFactoryWrapper &&) = delete;
    QGeoPositionInfoSourceFactoryWrapper& operator=(QGeoPositionInfoSourceFactoryWrapper &&) = delete;
    ~QGeoPositionInfoSourceFactoryWrapper() override;

    ::QGeoAreaMonitorSource * areaMonitor(::QObject * parent, const ::QMap<QString,QVariant> & parameters) override;
    static ::QGeoAreaMonitorSource * sbk_o_areaMonitor(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * parent, const ::QMap<QString,QVariant> & parameters);
    ::QGeoPositionInfoSource * positionInfoSource(::QObject * parent, const ::QMap<QString,QVariant> & parameters) override;
    static ::QGeoPositionInfoSource * sbk_o_positionInfoSource(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * parent, const ::QMap<QString,QVariant> & parameters);
    ::QGeoSatelliteInfoSource * satelliteInfoSource(::QObject * parent, const ::QMap<QString,QVariant> & parameters) override;
    static ::QGeoSatelliteInfoSource * sbk_o_satelliteInfoSource(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * parent, const ::QMap<QString,QVariant> & parameters);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QGEOPOSITIONINFOSOURCEFACTORYWRAPPER_H
