// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLABSTRACTURLINTERCEPTORWRAPPER_H
#define SBK_QQMLABSTRACTURLINTERCEPTORWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlabstracturlinterceptor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlAbstractUrlInterceptorWrapper : public QQmlAbstractUrlInterceptor
{
public:
    QQmlAbstractUrlInterceptorWrapper();
    QQmlAbstractUrlInterceptorWrapper(const QQmlAbstractUrlInterceptorWrapper &) = delete;
    QQmlAbstractUrlInterceptorWrapper& operator=(const QQmlAbstractUrlInterceptorWrapper &) = delete;
    QQmlAbstractUrlInterceptorWrapper(QQmlAbstractUrlInterceptorWrapper &&) = delete;
    QQmlAbstractUrlInterceptorWrapper& operator=(QQmlAbstractUrlInterceptorWrapper &&) = delete;
    ~QQmlAbstractUrlInterceptorWrapper() override;

    ::QUrl intercept(const ::QUrl & path, ::QQmlAbstractUrlInterceptor::DataType type) override;
    static ::QUrl sbk_o_intercept(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QUrl & path, ::QQmlAbstractUrlInterceptor::DataType type);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQMLABSTRACTURLINTERCEPTORWRAPPER_H
