// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLINCUBATIONCONTROLLERWRAPPER_H
#define SBK_QQMLINCUBATIONCONTROLLERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlincubator.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlIncubationControllerWrapper : public QQmlIncubationController
{
public:
    QQmlIncubationControllerWrapper();
    QQmlIncubationControllerWrapper(const QQmlIncubationControllerWrapper &) = delete;
    QQmlIncubationControllerWrapper& operator=(const QQmlIncubationControllerWrapper &) = delete;
    QQmlIncubationControllerWrapper(QQmlIncubationControllerWrapper &&) = delete;
    QQmlIncubationControllerWrapper& operator=(QQmlIncubationControllerWrapper &&) = delete;
    ~QQmlIncubationControllerWrapper() override;

    void incubatingObjectCountChanged(int arg__1) override;
    static void sbk_o_incubatingObjectCountChanged(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int arg__1);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQMLINCUBATIONCONTROLLERWRAPPER_H
