// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLNETWORKACCESSMANAGERFACTORYWRAPPER_H
#define SBK_QQMLNETWORKACCESSMANAGERFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlnetworkaccessmanagerfactory.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlNetworkAccessManagerFactoryWrapper : public QQmlNetworkAccessManagerFactory
{
public:
    QQmlNetworkAccessManagerFactoryWrapper();
    QQmlNetworkAccessManagerFactoryWrapper(const QQmlNetworkAccessManagerFactoryWrapper &) = delete;
    QQmlNetworkAccessManagerFactoryWrapper& operator=(const QQmlNetworkAccessManagerFactoryWrapper &) = delete;
    QQmlNetworkAccessManagerFactoryWrapper(QQmlNetworkAccessManagerFactoryWrapper &&) = delete;
    QQmlNetworkAccessManagerFactoryWrapper& operator=(QQmlNetworkAccessManagerFactoryWrapper &&) = delete;
    ~QQmlNetworkAccessManagerFactoryWrapper() override;

    ::QNetworkAccessManager * create(::QObject * parent) override;
    static ::QNetworkAccessManager * sbk_o_create(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * parent);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQMLNETWORKACCESSMANAGERFACTORYWRAPPER_H
