// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLPARSERSTATUSWRAPPER_H
#define SBK_QQMLPARSERSTATUSWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlparserstatus.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlParserStatusWrapper : public QQmlParserStatus
{
public:
    QQmlParserStatusWrapper();
    QQmlParserStatusWrapper(const QQmlParserStatusWrapper &) = delete;
    QQmlParserStatusWrapper& operator=(const QQmlParserStatusWrapper &) = delete;
    QQmlParserStatusWrapper(QQmlParserStatusWrapper &&) = delete;
    QQmlParserStatusWrapper& operator=(QQmlParserStatusWrapper &&) = delete;
    ~QQmlParserStatusWrapper() override;

    void classBegin() override;
    static void sbk_o_classBegin(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void componentComplete() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QQMLPARSERSTATUSWRAPPER_H
