// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQMLTYPESEXTENSIONINTERFACEWRAPPER_H
#define SBK_QQMLTYPESEXTENSIONINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQml/qqmlextensioninterface.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQmlTypesExtensionInterfaceWrapper : public QQmlTypesExtensionInterface
{
public:
    QQmlTypesExtensionInterfaceWrapper();
    QQmlTypesExtensionInterfaceWrapper(const QQmlTypesExtensionInterfaceWrapper &) = delete;
    QQmlTypesExtensionInterfaceWrapper& operator=(const QQmlTypesExtensionInterfaceWrapper &) = delete;
    QQmlTypesExtensionInterfaceWrapper(QQmlTypesExtensionInterfaceWrapper &&) = delete;
    QQmlTypesExtensionInterfaceWrapper& operator=(QQmlTypesExtensionInterfaceWrapper &&) = delete;
    ~QQmlTypesExtensionInterfaceWrapper() override;

    void registerTypes(const char * uri) override;
    static void sbk_o_registerTypes(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const char * uri);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QQMLTYPESEXTENSIONINTERFACEWRAPPER_H
