// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQUICKIMAGERESPONSEWRAPPER_H
#define SBK_QQUICKIMAGERESPONSEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickimageprovider.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QQuickImageResponseWrapper : public QQuickImageResponse
{
public:
    QQuickImageResponseWrapper();
    QQuickImageResponseWrapper(const QQuickImageResponseWrapper &) = delete;
    QQuickImageResponseWrapper& operator=(const QQuickImageResponseWrapper &) = delete;
    QQuickImageResponseWrapper(QQuickImageResponseWrapper &&) = delete;
    QQuickImageResponseWrapper& operator=(QQuickImageResponseWrapper &&) = delete;
    ~QQuickImageResponseWrapper() override;

    void cancel() override;
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    ::QString errorString() const override;
    static ::QString sbk_o_errorString(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QQuickTextureFactory * textureFactory() const override;
    static ::QQuickTextureFactory * sbk_o_textureFactory(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[10] = {false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QQUICKIMAGERESPONSEWRAPPER_H
