// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QQUICKRHIITEMRENDERERWRAPPER_H
#define SBK_QQUICKRHIITEMRENDERERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qquickrhiitem.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QQuickRhiItemRendererWrapper : public QQuickRhiItemRenderer
{
public:
    QQuickRhiItemRendererWrapper();
    QQuickRhiItemRendererWrapper(const QQuickRhiItemRendererWrapper &) = delete;
    QQuickRhiItemRendererWrapper& operator=(const QQuickRhiItemRendererWrapper &) = delete;
    QQuickRhiItemRendererWrapper(QQuickRhiItemRendererWrapper &&) = delete;
    QQuickRhiItemRendererWrapper& operator=(QQuickRhiItemRendererWrapper &&) = delete;
    ~QQuickRhiItemRendererWrapper() override;

    void initialize(::QRhiCommandBuffer * cb) override;
    static void sbk_o_initialize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QRhiCommandBuffer * cb);
    void render(::QRhiCommandBuffer * cb) override;
    void synchronize(::QQuickRhiItem * item) override;
    static void sbk_o_synchronize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQuickRhiItem * item);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QQUICKRHIITEMRENDERERWRAPPER_H
