// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGGEOMETRYWRAPPER_H
#define SBK_QSGGEOMETRYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsggeometry.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGGeometryWrapper : public QSGGeometry
{
public:
    QSGGeometryWrapper(const ::QSGGeometry::AttributeSet & attribs, int vertexCount, int indexCount = 0, int indexType = QSGGeometry::Type::UnsignedShortType);
    QSGGeometryWrapper(const QSGGeometryWrapper &) = delete;
    QSGGeometryWrapper& operator=(const QSGGeometryWrapper &) = delete;
    QSGGeometryWrapper(QSGGeometryWrapper &&) = delete;
    QSGGeometryWrapper& operator=(QSGGeometryWrapper &&) = delete;
    ~QSGGeometryWrapper() override;

    static void pysideInitQtMetaTypes();

private:
};

#endif // SBK_QSGGEOMETRYWRAPPER_H
