// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGNODEWRAPPER_H
#define SBK_QSGNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGNodeWrapper : public QSGNode
{
public:
    QSGNodeWrapper();
    QSGNodeWrapper(::QSGNode::NodeType type);
    QSGNodeWrapper(const QSGNodeWrapper &) = delete;
    QSGNodeWrapper& operator=(const QSGNodeWrapper &) = delete;
    QSGNodeWrapper(QSGNodeWrapper &&) = delete;
    QSGNodeWrapper& operator=(QSGNodeWrapper &&) = delete;
    ~QSGNodeWrapper() override;

    bool isSubtreeBlocked() const override;
    static bool sbk_o_isSubtreeBlocked(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void preprocess() override;
    static void sbk_o_preprocess(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGNODEWRAPPER_H
