// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGRECTANGLENODEWRAPPER_H
#define SBK_QSGRECTANGLENODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgrectanglenode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGRectangleNodeWrapper : public QSGRectangleNode
{
public:
    QSGRectangleNodeWrapper();
    QSGRectangleNodeWrapper(const QSGRectangleNodeWrapper &) = delete;
    QSGRectangleNodeWrapper& operator=(const QSGRectangleNodeWrapper &) = delete;
    QSGRectangleNodeWrapper(QSGRectangleNodeWrapper &&) = delete;
    QSGRectangleNodeWrapper& operator=(QSGRectangleNodeWrapper &&) = delete;
    ~QSGRectangleNodeWrapper() override;

    ::QColor color() const override;
    bool isSubtreeBlocked() const override;
    void preprocess() override;
    ::QRectF rect() const override;
    void setColor(const ::QColor & color) override;
    static void sbk_o_setColor(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QColor & color);
    void setRect(const ::QRectF & rect) override;
    // Inherited overloads, because the using keyword sux
    void setRect(qreal x, qreal y, qreal w, qreal h) { QSGRectangleNode::setRect(x, y, w, h); }

    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QSGRECTANGLENODEWRAPPER_H
