// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGRENDERERINTERFACEWRAPPER_H
#define SBK_QSGRENDERERINTERFACEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgrendererinterface.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGRendererInterfaceWrapper : public QSGRendererInterface
{
public:
    QSGRendererInterfaceWrapper();
    QSGRendererInterfaceWrapper(const QSGRendererInterfaceWrapper &) = delete;
    QSGRendererInterfaceWrapper& operator=(const QSGRendererInterfaceWrapper &) = delete;
    QSGRendererInterfaceWrapper(QSGRendererInterfaceWrapper &&) = delete;
    QSGRendererInterfaceWrapper& operator=(QSGRendererInterfaceWrapper &&) = delete;
    ~QSGRendererInterfaceWrapper() override;

    void * getResource(::QQuickWindow * window, ::QSGRendererInterface::Resource resource) const override;
    static void * sbk_o_getResource(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQuickWindow * window, ::QSGRendererInterface::Resource resource);
    void * getResource(::QQuickWindow * window, const char * resource) const override;
    static void * sbk_o_getResource(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QQuickWindow * window, const char * resource);
    ::QSGRendererInterface::GraphicsApi graphicsApi() const override;
    static ::QSGRendererInterface::GraphicsApi sbk_o_graphicsApi(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QFlags<QSGRendererInterface::ShaderCompilationType> shaderCompilationType() const override;
    static ::QFlags<QSGRendererInterface::ShaderCompilationType> sbk_o_shaderCompilationType(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QFlags<QSGRendererInterface::ShaderSourceType> shaderSourceType() const override;
    static ::QFlags<QSGRendererInterface::ShaderSourceType> sbk_o_shaderSourceType(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    ::QSGRendererInterface::ShaderType shaderType() const override;
    static ::QSGRendererInterface::ShaderType sbk_o_shaderType(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[6] = {false, false, false, false, false, false};
};

#endif // SBK_QSGRENDERERINTERFACEWRAPPER_H
