// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSGSIMPLERECTNODEWRAPPER_H
#define SBK_QSGSIMPLERECTNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtQuick/qsgsimplerectnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSGSimpleRectNodeWrapper : public QSGSimpleRectNode
{
public:
    QSGSimpleRectNodeWrapper();
    QSGSimpleRectNodeWrapper(const ::QRectF & rect, const ::QColor & color);
    QSGSimpleRectNodeWrapper(const QSGSimpleRectNodeWrapper &) = delete;
    QSGSimpleRectNodeWrapper& operator=(const QSGSimpleRectNodeWrapper &) = delete;
    QSGSimpleRectNodeWrapper(QSGSimpleRectNodeWrapper &&) = delete;
    QSGSimpleRectNodeWrapper& operator=(QSGSimpleRectNodeWrapper &&) = delete;
    ~QSGSimpleRectNodeWrapper() override;

    bool isSubtreeBlocked() const override;
    void preprocess() override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QSGSIMPLERECTNODEWRAPPER_H
