// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCONNECTIONABSTRACTSERVERWRAPPER_H
#define SBK_QCONNECTIONABSTRACTSERVERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qconnectionfactories.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QConnectionAbstractServerWrapper : public QConnectionAbstractServer
{
public:
    QConnectionAbstractServerWrapper(::QObject * parent = nullptr);
    QConnectionAbstractServerWrapper(const QConnectionAbstractServerWrapper &) = delete;
    QConnectionAbstractServerWrapper& operator=(const QConnectionAbstractServerWrapper &) = delete;
    QConnectionAbstractServerWrapper(QConnectionAbstractServerWrapper &&) = delete;
    QConnectionAbstractServerWrapper& operator=(QConnectionAbstractServerWrapper &&) = delete;
    ~QConnectionAbstractServerWrapper() override;

    ::QUrl address() const override;
    static ::QUrl sbk_o_address(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void childEvent(::QChildEvent * event) override;
    void close() override;
    ::QtROServerIoDevice * configureNewConnection() override;
    static ::QtROServerIoDevice * sbk_o_configureNewConnection(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool hasPendingConnections() const override;
    bool listen(const ::QUrl & address) override;
    ::QAbstractSocket::SocketError serverError() const override;
    static ::QAbstractSocket::SocketError sbk_o_serverError(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[13] = {false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QCONNECTIONABSTRACTSERVERWRAPPER_H
