// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QREMOTEOBJECTABSTRACTPERSISTEDSTOREWRAPPER_H
#define SBK_QREMOTEOBJECTABSTRACTPERSISTEDSTOREWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qremoteobjectnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QRemoteObjectAbstractPersistedStoreWrapper : public QRemoteObjectAbstractPersistedStore
{
public:
    QRemoteObjectAbstractPersistedStoreWrapper(::QObject * parent = nullptr);
    QRemoteObjectAbstractPersistedStoreWrapper(const QRemoteObjectAbstractPersistedStoreWrapper &) = delete;
    QRemoteObjectAbstractPersistedStoreWrapper& operator=(const QRemoteObjectAbstractPersistedStoreWrapper &) = delete;
    QRemoteObjectAbstractPersistedStoreWrapper(QRemoteObjectAbstractPersistedStoreWrapper &&) = delete;
    QRemoteObjectAbstractPersistedStoreWrapper& operator=(QRemoteObjectAbstractPersistedStoreWrapper &&) = delete;
    ~QRemoteObjectAbstractPersistedStoreWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    ::QList<QVariant> restoreProperties(const ::QString & repName, const ::QByteArray & repSig) override;
    static ::QList<QVariant> sbk_o_restoreProperties(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & repName, const ::QByteArray & repSig);
    void saveProperties(const ::QString & repName, const ::QByteArray & repSig, const ::QList<QVariant> & values) override;
    static void sbk_o_saveProperties(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & repName, const ::QByteArray & repSig, const ::QList<QVariant> & values);
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QREMOTEOBJECTABSTRACTPERSISTEDSTOREWRAPPER_H
