// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QREMOTEOBJECTNODEWRAPPER_H
#define SBK_QREMOTEOBJECTNODEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qremoteobjectnode.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QRemoteObjectNodeWrapper : public QRemoteObjectNode
{
public:
    QRemoteObjectNodeWrapper(::QObject * parent = nullptr);
    QRemoteObjectNodeWrapper(const ::QUrl & registryAddress, ::QObject * parent = nullptr);
    QRemoteObjectNodeWrapper(const QRemoteObjectNodeWrapper &) = delete;
    QRemoteObjectNodeWrapper& operator=(const QRemoteObjectNodeWrapper &) = delete;
    QRemoteObjectNodeWrapper(QRemoteObjectNodeWrapper &&) = delete;
    QRemoteObjectNodeWrapper& operator=(QRemoteObjectNodeWrapper &&) = delete;
    ~QRemoteObjectNodeWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void setName(const ::QString & name) override;
    static void sbk_o_setName(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & name);
    bool setRegistryUrl(const ::QUrl & registryAddress) override;
    static bool sbk_o_setRegistryUrl(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QUrl & registryAddress);
    void timerEvent(::QTimerEvent * arg__1) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QREMOTEOBJECTNODEWRAPPER_H
