// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTROSERVERIODEVICEWRAPPER_H
#define SBK_QTROSERVERIODEVICEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtRemoteObjects/qconnectionfactories.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QtROServerIoDeviceWrapper : public QtROServerIoDevice
{
public:
    QtROServerIoDeviceWrapper(::QObject * parent = nullptr);
    QtROServerIoDeviceWrapper(const QtROServerIoDeviceWrapper &) = delete;
    QtROServerIoDeviceWrapper& operator=(const QtROServerIoDeviceWrapper &) = delete;
    QtROServerIoDeviceWrapper(QtROServerIoDeviceWrapper &&) = delete;
    QtROServerIoDeviceWrapper& operator=(QtROServerIoDeviceWrapper &&) = delete;
    ~QtROServerIoDeviceWrapper() override;

    qint64 bytesAvailable() const override;
    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QIODevice * connection() const override;
    void customEvent(::QEvent * event) override;
    ::QString deviceType() const override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    void doClose() override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool isOpen() const override;
    void timerEvent(::QTimerEvent * event) override;
    void write(const ::QByteArray & data) override;
    void write(const ::QByteArray & data, qint64 arg__2) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[15] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QTROSERVERIODEVICEWRAPPER_H
