// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_FOREACHLOOPBODYWRAPPER_H
#define SBK_FOREACHLOOPBODYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtScxml/qscxmldatamodel.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class ForeachLoopBodyWrapper : public QScxmlDataModel::ForeachLoopBody
{
public:
    ForeachLoopBodyWrapper();
    ForeachLoopBodyWrapper(const ForeachLoopBodyWrapper &) = delete;
    ForeachLoopBodyWrapper& operator=(const ForeachLoopBodyWrapper &) = delete;
    ForeachLoopBodyWrapper(ForeachLoopBodyWrapper &&) = delete;
    ForeachLoopBodyWrapper& operator=(ForeachLoopBodyWrapper &&) = delete;
    ~ForeachLoopBodyWrapper() override;

    void run(bool * ok) override;
    static void sbk_o_run(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, bool * ok);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_FOREACHLOOPBODYWRAPPER_H
