// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QACCELEROMETERFILTERWRAPPER_H
#define SBK_QACCELEROMETERFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qaccelerometer.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAccelerometerFilterWrapper : public QAccelerometerFilter
{
public:
    QAccelerometerFilterWrapper(const QAccelerometerFilterWrapper &) = delete;
    QAccelerometerFilterWrapper& operator=(const QAccelerometerFilterWrapper &) = delete;
    QAccelerometerFilterWrapper(QAccelerometerFilterWrapper &&) = delete;
    QAccelerometerFilterWrapper& operator=(QAccelerometerFilterWrapper &&) = delete;
    ~QAccelerometerFilterWrapper() override;

    bool filter(::QAccelerometerReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QAccelerometerReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QACCELEROMETERFILTERWRAPPER_H
