// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QAMBIENTLIGHTFILTERWRAPPER_H
#define SBK_QAMBIENTLIGHTFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qambientlightsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QAmbientLightFilterWrapper : public QAmbientLightFilter
{
public:
    QAmbientLightFilterWrapper(const QAmbientLightFilterWrapper &) = delete;
    QAmbientLightFilterWrapper& operator=(const QAmbientLightFilterWrapper &) = delete;
    QAmbientLightFilterWrapper(QAmbientLightFilterWrapper &&) = delete;
    QAmbientLightFilterWrapper& operator=(QAmbientLightFilterWrapper &&) = delete;
    ~QAmbientLightFilterWrapper() override;

    bool filter(::QAmbientLightReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QAmbientLightReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QAMBIENTLIGHTFILTERWRAPPER_H
