// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QCOMPASSFILTERWRAPPER_H
#define SBK_QCOMPASSFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qcompass.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QCompassFilterWrapper : public QCompassFilter
{
public:
    QCompassFilterWrapper(const QCompassFilterWrapper &) = delete;
    QCompassFilterWrapper& operator=(const QCompassFilterWrapper &) = delete;
    QCompassFilterWrapper(QCompassFilterWrapper &&) = delete;
    QCompassFilterWrapper& operator=(QCompassFilterWrapper &&) = delete;
    ~QCompassFilterWrapper() override;

    bool filter(::QCompassReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QCompassReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QCOMPASSFILTERWRAPPER_H
