// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMAGNETOMETERFILTERWRAPPER_H
#define SBK_QMAGNETOMETERFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qmagnetometer.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QMagnetometerFilterWrapper : public QMagnetometerFilter
{
public:
    QMagnetometerFilterWrapper(const QMagnetometerFilterWrapper &) = delete;
    QMagnetometerFilterWrapper& operator=(const QMagnetometerFilterWrapper &) = delete;
    QMagnetometerFilterWrapper(QMagnetometerFilterWrapper &&) = delete;
    QMagnetometerFilterWrapper& operator=(QMagnetometerFilterWrapper &&) = delete;
    ~QMagnetometerFilterWrapper() override;

    bool filter(::QMagnetometerReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QMagnetometerReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QMAGNETOMETERFILTERWRAPPER_H
