// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QROTATIONFILTERWRAPPER_H
#define SBK_QROTATIONFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qrotationsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QRotationFilterWrapper : public QRotationFilter
{
public:
    QRotationFilterWrapper(const QRotationFilterWrapper &) = delete;
    QRotationFilterWrapper& operator=(const QRotationFilterWrapper &) = delete;
    QRotationFilterWrapper(QRotationFilterWrapper &&) = delete;
    QRotationFilterWrapper& operator=(QRotationFilterWrapper &&) = delete;
    ~QRotationFilterWrapper() override;

    bool filter(::QRotationReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QRotationReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QROTATIONFILTERWRAPPER_H
