// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTAPFILTERWRAPPER_H
#define SBK_QTAPFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qtapsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QTapFilterWrapper : public QTapFilter
{
public:
    QTapFilterWrapper(const QTapFilterWrapper &) = delete;
    QTapFilterWrapper& operator=(const QTapFilterWrapper &) = delete;
    QTapFilterWrapper(QTapFilterWrapper &&) = delete;
    QTapFilterWrapper& operator=(QTapFilterWrapper &&) = delete;
    ~QTapFilterWrapper() override;

    bool filter(::QTapReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QTapReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QTAPFILTERWRAPPER_H
