// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QTILTFILTERWRAPPER_H
#define SBK_QTILTFILTERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSensors/qtiltsensor.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QTiltFilterWrapper : public QTiltFilter
{
public:
    QTiltFilterWrapper(const QTiltFilterWrapper &) = delete;
    QTiltFilterWrapper& operator=(const QTiltFilterWrapper &) = delete;
    QTiltFilterWrapper(QTiltFilterWrapper &&) = delete;
    QTiltFilterWrapper& operator=(QTiltFilterWrapper &&) = delete;
    ~QTiltFilterWrapper() override;

    bool filter(::QTiltReading * reading) override;
    static bool sbk_o_filter(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QTiltReading * reading);
    void setSensor(::QSensor * sensor) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QTILTFILTERWRAPPER_H
