// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMODBUSPDUWRAPPER_H
#define SBK_QMODBUSPDUWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QModbusPduWrapper : public QModbusPdu
{
public:
    QModbusPduWrapper();
    QModbusPduWrapper(::QModbusPdu::FunctionCode code, const ::QByteArray & newData);
    QModbusPduWrapper(const QModbusPduWrapper &) = delete;
    QModbusPduWrapper(const QModbusPdu& self) : QModbusPdu(self)
    {
    }
    QModbusPduWrapper& operator=(const QModbusPduWrapper &) = delete;
    QModbusPduWrapper(QModbusPduWrapper &&) = delete;
    QModbusPduWrapper& operator=(QModbusPduWrapper &&) = delete;
    ~QModbusPduWrapper() override;

    void setFunctionCode(::QModbusPdu::FunctionCode code) override;
    static void sbk_o_setFunctionCode(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QModbusPdu::FunctionCode code);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QMODBUSPDUWRAPPER_H
