// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMODBUSREQUESTWRAPPER_H
#define SBK_QMODBUSREQUESTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbuspdu.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QModbusRequestWrapper : public QModbusRequest
{
public:
    QModbusRequestWrapper();
    QModbusRequestWrapper(::QModbusPdu::FunctionCode code, const ::QByteArray & newData = QByteArray());
    QModbusRequestWrapper(const ::QModbusPdu & pdu);
    QModbusRequestWrapper(const QModbusRequestWrapper &) = delete;
    QModbusRequestWrapper& operator=(const QModbusRequestWrapper &) = delete;
    QModbusRequestWrapper(QModbusRequestWrapper &&) = delete;
    QModbusRequestWrapper& operator=(QModbusRequestWrapper &&) = delete;
    ~QModbusRequestWrapper() override;

    void setFunctionCode(::QModbusPdu::FunctionCode code) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QMODBUSREQUESTWRAPPER_H
