// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QMODBUSTCPCLIENTWRAPPER_H
#define SBK_QMODBUSTCPCLIENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSerialBus/qmodbustcpclient.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class QModbusTcpClientWrapper : public QModbusTcpClient
{
public:
    QModbusTcpClientWrapper(::QObject * parent = nullptr);
    QModbusTcpClientWrapper(const QModbusTcpClientWrapper &) = delete;
    QModbusTcpClientWrapper& operator=(const QModbusTcpClientWrapper &) = delete;
    QModbusTcpClientWrapper(QModbusTcpClientWrapper &&) = delete;
    QModbusTcpClientWrapper& operator=(QModbusTcpClientWrapper &&) = delete;
    ~QModbusTcpClientWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool open() override;
    bool processPrivateResponse(const ::QModbusResponse & response, ::QModbusDataUnit * data) override;
    bool processResponse(const ::QModbusResponse & response, ::QModbusDataUnit * data) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[11] = {false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QMODBUSTCPCLIENTWRAPPER_H
