// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QSQLDRIVERCREATORBASEWRAPPER_H
#define SBK_QSQLDRIVERCREATORBASEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtSql/qsqldatabase.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QSqlDriverCreatorBaseWrapper : public QSqlDriverCreatorBase
{
public:
    QSqlDriverCreatorBaseWrapper();
    QSqlDriverCreatorBaseWrapper(const QSqlDriverCreatorBaseWrapper &) = delete;
    QSqlDriverCreatorBaseWrapper& operator=(const QSqlDriverCreatorBaseWrapper &) = delete;
    QSqlDriverCreatorBaseWrapper(QSqlDriverCreatorBaseWrapper &&) = delete;
    QSqlDriverCreatorBaseWrapper& operator=(QSqlDriverCreatorBaseWrapper &&) = delete;
    ~QSqlDriverCreatorBaseWrapper() override;

    ::QSqlDriver * createObject() const override;
    static ::QSqlDriver * sbk_o_createObject(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QSQLDRIVERCREATORBASEWRAPPER_H
