// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_WRAPPEDEVENTWRAPPER_H
#define SBK_WRAPPEDEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtStateMachine/qstatemachine.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class WrappedEventWrapper : public QStateMachine::WrappedEvent
{
public:
    WrappedEventWrapper(::QObject * object, ::QEvent * event);
    WrappedEventWrapper(const WrappedEventWrapper &) = delete;
    WrappedEventWrapper& operator=(const WrappedEventWrapper &) = delete;
    WrappedEventWrapper(WrappedEventWrapper &&) = delete;
    WrappedEventWrapper& operator=(WrappedEventWrapper &&) = delete;
    ~WrappedEventWrapper() override;

    ::QEvent * clone() const override;
    static ::QEvent * sbk_o_clone(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride);
    void setAccepted(bool accepted) override;
    static void sbk_o_setAccepted(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, bool accepted);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_WRAPPEDEVENTWRAPPER_H
