// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGESTUREEVENTWRAPPER_H
#define SBK_QGESTUREEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgesture.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGestureEventWrapper : public QGestureEvent
{
public:
    QGestureEventWrapper(const ::QList<QGesture*> & gestures);
    QGestureEventWrapper(const QGestureEventWrapper &) = delete;
    QGestureEventWrapper& operator=(const QGestureEventWrapper &) = delete;
    QGestureEventWrapper(QGestureEventWrapper &&) = delete;
    QGestureEventWrapper& operator=(QGestureEventWrapper &&) = delete;
    ~QGestureEventWrapper() override;

    ::QEvent * clone() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[1] = {false};
};

#endif // SBK_QGESTUREEVENTWRAPPER_H
