// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGESTURERECOGNIZERWRAPPER_H
#define SBK_QGESTURERECOGNIZERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgesturerecognizer.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGestureRecognizerWrapper : public QGestureRecognizer
{
public:
    QGestureRecognizerWrapper();
    QGestureRecognizerWrapper(const QGestureRecognizerWrapper &) = delete;
    QGestureRecognizerWrapper& operator=(const QGestureRecognizerWrapper &) = delete;
    QGestureRecognizerWrapper(QGestureRecognizerWrapper &&) = delete;
    QGestureRecognizerWrapper& operator=(QGestureRecognizerWrapper &&) = delete;
    ~QGestureRecognizerWrapper() override;

    ::QGesture * create(::QObject * target) override;
    static ::QGesture * sbk_o_create(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QObject * target);
    ::QFlags<QGestureRecognizer::ResultFlag> recognize(::QGesture * state, ::QObject * watched, ::QEvent * event) override;
    static ::QFlags<QGestureRecognizer::ResultFlag> sbk_o_recognize(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QGesture * state, ::QObject * watched, ::QEvent * event);
    void reset(::QGesture * state) override;
    static void sbk_o_reset(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, ::QGesture * state);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_QGESTURERECOGNIZERWRAPPER_H
