// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENECONTEXTMENUEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENECONTEXTMENUEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneContextMenuEventWrapper : public QGraphicsSceneContextMenuEvent
{
public:
    QGraphicsSceneContextMenuEventWrapper(::QEvent::Type type = QEvent::Type::None);
    QGraphicsSceneContextMenuEventWrapper(const QGraphicsSceneContextMenuEventWrapper &) = delete;
    QGraphicsSceneContextMenuEventWrapper& operator=(const QGraphicsSceneContextMenuEventWrapper &) = delete;
    QGraphicsSceneContextMenuEventWrapper(QGraphicsSceneContextMenuEventWrapper &&) = delete;
    QGraphicsSceneContextMenuEventWrapper& operator=(QGraphicsSceneContextMenuEventWrapper &&) = delete;
    ~QGraphicsSceneContextMenuEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENECONTEXTMENUEVENTWRAPPER_H
