// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENEHELPEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENEHELPEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneHelpEventWrapper : public QGraphicsSceneHelpEvent
{
public:
    QGraphicsSceneHelpEventWrapper(::QEvent::Type type = QEvent::Type::None);
    QGraphicsSceneHelpEventWrapper(const QGraphicsSceneHelpEventWrapper &) = delete;
    QGraphicsSceneHelpEventWrapper& operator=(const QGraphicsSceneHelpEventWrapper &) = delete;
    QGraphicsSceneHelpEventWrapper(QGraphicsSceneHelpEventWrapper &&) = delete;
    QGraphicsSceneHelpEventWrapper& operator=(QGraphicsSceneHelpEventWrapper &&) = delete;
    ~QGraphicsSceneHelpEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENEHELPEVENTWRAPPER_H
