// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENEHOVEREVENTWRAPPER_H
#define SBK_QGRAPHICSSCENEHOVEREVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneHoverEventWrapper : public QGraphicsSceneHoverEvent
{
public:
    QGraphicsSceneHoverEventWrapper(::QEvent::Type type = QEvent::Type::None);
    QGraphicsSceneHoverEventWrapper(const QGraphicsSceneHoverEventWrapper &) = delete;
    QGraphicsSceneHoverEventWrapper& operator=(const QGraphicsSceneHoverEventWrapper &) = delete;
    QGraphicsSceneHoverEventWrapper(QGraphicsSceneHoverEventWrapper &&) = delete;
    QGraphicsSceneHoverEventWrapper& operator=(QGraphicsSceneHoverEventWrapper &&) = delete;
    ~QGraphicsSceneHoverEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENEHOVEREVENTWRAPPER_H
