// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENEMOUSEEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENEMOUSEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneMouseEventWrapper : public QGraphicsSceneMouseEvent
{
public:
    QGraphicsSceneMouseEventWrapper(::QEvent::Type type = QEvent::Type::None);
    QGraphicsSceneMouseEventWrapper(const QGraphicsSceneMouseEventWrapper &) = delete;
    QGraphicsSceneMouseEventWrapper& operator=(const QGraphicsSceneMouseEventWrapper &) = delete;
    QGraphicsSceneMouseEventWrapper(QGraphicsSceneMouseEventWrapper &&) = delete;
    QGraphicsSceneMouseEventWrapper& operator=(QGraphicsSceneMouseEventWrapper &&) = delete;
    ~QGraphicsSceneMouseEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENEMOUSEEVENTWRAPPER_H
