// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENEMOVEEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENEMOVEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneMoveEventWrapper : public QGraphicsSceneMoveEvent
{
public:
    QGraphicsSceneMoveEventWrapper();
    QGraphicsSceneMoveEventWrapper(const QGraphicsSceneMoveEventWrapper &) = delete;
    QGraphicsSceneMoveEventWrapper& operator=(const QGraphicsSceneMoveEventWrapper &) = delete;
    QGraphicsSceneMoveEventWrapper(QGraphicsSceneMoveEventWrapper &&) = delete;
    QGraphicsSceneMoveEventWrapper& operator=(QGraphicsSceneMoveEventWrapper &&) = delete;
    ~QGraphicsSceneMoveEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENEMOVEEVENTWRAPPER_H
