// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QGRAPHICSSCENERESIZEEVENTWRAPPER_H
#define SBK_QGRAPHICSSCENERESIZEEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qgraphicssceneevent.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QGraphicsSceneResizeEventWrapper : public QGraphicsSceneResizeEvent
{
public:
    QGraphicsSceneResizeEventWrapper();
    QGraphicsSceneResizeEventWrapper(const QGraphicsSceneResizeEventWrapper &) = delete;
    QGraphicsSceneResizeEventWrapper& operator=(const QGraphicsSceneResizeEventWrapper &) = delete;
    QGraphicsSceneResizeEventWrapper(QGraphicsSceneResizeEventWrapper &&) = delete;
    QGraphicsSceneResizeEventWrapper& operator=(QGraphicsSceneResizeEventWrapper &&) = delete;
    ~QGraphicsSceneResizeEventWrapper() override;

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QGRAPHICSSCENERESIZEEVENTWRAPPER_H
