// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QITEMEDITORFACTORYWRAPPER_H
#define SBK_QITEMEDITORFACTORYWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qitemeditorfactory.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QItemEditorFactoryWrapper : public QItemEditorFactory
{
public:
    QItemEditorFactoryWrapper();
    QItemEditorFactoryWrapper(const QItemEditorFactoryWrapper &) = delete;
    QItemEditorFactoryWrapper& operator=(const QItemEditorFactoryWrapper &) = delete;
    QItemEditorFactoryWrapper(QItemEditorFactoryWrapper &&) = delete;
    QItemEditorFactoryWrapper& operator=(QItemEditorFactoryWrapper &&) = delete;
    ~QItemEditorFactoryWrapper() override;

    ::QWidget * createEditor(int userType, ::QWidget * parent) const override;
    static ::QWidget * sbk_o_createEditor(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int userType, ::QWidget * parent);
    ::QByteArray valuePropertyName(int userType) const override;
    static ::QByteArray sbk_o_valuePropertyName(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, int userType);
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[2] = {false, false};
};

#endif // SBK_QITEMEDITORFACTORYWRAPPER_H
