// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWIDGETITEMWRAPPER_H
#define SBK_QWIDGETITEMWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWidgets/qlayoutitem.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class QWidgetItemWrapper : public QWidgetItem
{
public:
    QWidgetItemWrapper(::QWidget * w);
    QWidgetItemWrapper(const QWidgetItemWrapper &) = delete;
    QWidgetItemWrapper& operator=(const QWidgetItemWrapper &) = delete;
    QWidgetItemWrapper(QWidgetItemWrapper &&) = delete;
    QWidgetItemWrapper& operator=(QWidgetItemWrapper &&) = delete;
    ~QWidgetItemWrapper() override;

    ::QFlags<QSizePolicy::ControlType> controlTypes() const override;
    ::QFlags<Qt::Orientation> expandingDirections() const override;
    ::QRect geometry() const override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    void invalidate() override;
    bool isEmpty() const override;
    ::QLayout * layout() override;
    ::QSize maximumSize() const override;
    int minimumHeightForWidth(int arg__1) const override;
    ::QSize minimumSize() const override;
    void setGeometry(const ::QRect & arg__1) override;
    ::QSize sizeHint() const override;
    ::QSpacerItem * spacerItem() override;
    ::QWidget * widget() const override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[15] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
};

#endif // SBK_QWIDGETITEMWRAPPER_H
